#include<bits/stdc++.h>
#define ll long long
using namespace std;
int N,niz[1000005];
bool zamenjen=false;
stack<int> cifre[15];
int main(){
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    cin>>N;
    for(int i=1;i<=N;i++){
        cin>>niz[i];
        cifre[niz[i]].push(i);
    }
    for(int i=1;i<=N;i++){
        for(int j=0;j<=9;j++)
            while(cifre[j].size()){
                if(cifre[j].top()>i)
                    break;
                cifre[j].pop();
            }
        /*for(int k=0;k<=9;k++)
        cout<<cifre[k].size()<<" ";
    cout<<i<<endl;*/
        for(int j=9;j>niz[i];j--)
            if(cifre[j].size()>=1){
                swap(niz[i],niz[cifre[j].top()]);
                zamenjen=true;
                break;
            }
        if(zamenjen)
            break;
    }
    if(!zamenjen)
        swap(niz[N],niz[N-1]);
    for(int i=1;i<=N;i++)
        cout<<niz[i]<<" ";
    cout<<endl;
    return 0;
}